build-a-docker-image.md
-----------------------
```
@version    180911:2
@author     zhangxuhong <zhangxuhong@xitu.io>
```

Name
----

    build-a-docker-image - 构建Docker镜像.

    
Table of Contents
-----------------

* [Name](#name)
* [Image Manifest Management 镜像依赖管理](#image-manifest-management)
* [Minimize Docker Image 缩减 Docker 镜像大小](#minimize-docker-image)


Image Manifest Management 镜像依赖管理
--------------------------------------

### 构建普通镜像

目前harbor中的镜像库包含以下几个项目

- lib, 公网上的镜像备份
- infrastructure, 私有基础镜像
- test, 测试用, 随便用, test发版用镜像
- beta, beta发版用镜像
- prod, prod发版用镜像

比如现在正在构建项目:

- harbor02.juejin.id/prod/demo-api

该项目依赖:

- harbor02.juejin.id/infrastructure/nginx-1.10.3-centos-with-lua-nginx-module:0.0.3
- harbor02.juejin.id/lib/framework:0.12.3

那么在引用依赖和发版的时候, 都应该使用latest tag的镜像, 这样可以保证每次新发布的时候, 可以获取最新的更新(需要手动把本地镜像缓存清理一下).  
所以依赖应该是:

- harbor02.juejin.id/infrastructure/nginx-1.10.3-centos-with-lua-nginx-module:latest
- harbor02.juejin.id/lib/framework:latest

这样当这两个项目有bugfix的时候, 只需要重新构建你的项目, 而不必修改Dockerfile.  

发布的时候, jenkins会自动执行你指定的jenkinsfile来把构建完毕的镜像推送到harbor, 镜像tag通常是git提交的hash值(这是在jenkinsfile自动生成的,不必手动修改).  

- harbor02.juejin.id/prod/demo-api:xxxxx 用来让CI程序进行发版


### 构建基础镜像

制作基础镜像也是同样的流程, 比如 harbor02.juejin.id/infrastructure/nginx-1.10.3-centos-with-lua-nginx-module 修正了一个bug, 那么版本变为:  

- harbor02.juejin.id/infrastructure/nginx-1.10.3-centos-with-lua-nginx-module:0.0.4

同时应再推送一个

- harbor02.juejin.id/infrastructure/nginx-1.10.3-centos-with-lua-nginx-module:latest

版本方便其他依赖该镜像的项目用来更新.


Minimize Docker Image 缩减 Docker 镜像大小
------------------------------------------

可以参考这篇文档:   

- [https://www.sandtable.com/reduce-docker-image-sizes-using-alpine/](https://www.sandtable.com/reduce-docker-image-sizes-using-alpine/)

基本思路就是用Alpine, 然后把不用的都删掉. 懒得删就用多端构建, 只把需要的bin和so拷贝过去.  

有个实用的工具 dlayer, 可以分析每一行dockerfile命令带来的镜像膨胀.  

- [https://github.com/orisano/dlayer](https://github.com/orisano/dlayer)

已经在docker-client01v.lobj.juejin.id部署, 可以直接使用.  
